"use strict";

function initialize(){
    /*** [ Configuration ] ***/
    var swogoLang;

    if(window.location.href.match(/mediamarkt.be\/\w+/g)[0].replace("mediamarkt.be/","") == "fr" || window.location.href.indexOf("langId=-29") >= 0) swogoLang =  "FR";
    if(window.location.href.match(/mediamarkt.be\/\w+/g)[0].replace("mediamarkt.be/","") == "nl" || window.location.href.indexOf("langId=-17") >= 0) swogoLang =  "NL";

    if(swogoLang) setCookie("swogoLang", swogoLang, 1);
    else  swogoLang = getCookie("swogoLang");

    var clientParams = {
        name : "mediamarktBe",
        language : swogoLang || "NL"
    };

    var variants = {
        "A": { value : 100}
    };
    var version = 1;
    /*** [ end - Configuration ] ***/

    // force Swogo variant parameter handling
    searchURL("forceSwogoVariant", forceVariant, deleteDevVariantCookies);

    /*** [ Loader ] ***/
    var scriptSrc = "//ui.swogo.com";
    if ( window.location.href.indexOf("swogo-disable") >=0 )  {
        console.log("Swogo-LOG","Live script disabled.");
        return;
    }
    removeExpiredVariants(variants);
    clientParams.variant = setVariant(variants,version);
    scriptSrc += "/"+clientParams.name+"/"+clientParams.variant+((clientParams.language)?"/"+clientParams.language:"")+"/swogo.js";
    appendScript(scriptSrc);


    function appendScript (scriptSrc) {
        if(!scriptSrc) return console.error("No swogo client script found for this language and variant");
        var script = document.createElement( 'script' );
        script.type = 'text/javascript';
        script.src = scriptSrc;
        document.querySelector("body").appendChild(script);
    }

    function removeExpiredVariants (variantsObj) {
        var nowDate = new Date();
        for(var variantName in variantsObj){
            var variantObj = variantsObj[variantName];
            if (variantObj.expireDate && new Date(variantObj.expireDate) <= nowDate) delete variantsObj[variantName];
        }
    }

    function setVariant (variantsObj, version) {
        var cVariant = getCookie("sw_var");
        var cVersion = getCookie("sw_var_ver") || -1;
        var variantsKey = Object.keys(variantsObj);
        var sumArray = 0;
        var acc = 0;
        variantsKey.reduce(function(a, b){return sumArray = sumArray + variantsObj[b].value}, 0);
        var randomVar = Math.random()*sumArray;
        for(var variantName in variantsObj){
            var variantObj = variantsObj[variantName];
            acc += variantObj.value;
            if(acc >= randomVar) break;
        }
        if( cVariant && cVersion && (version == cVersion) ){
            return cVariant;
        } else {
            setCookie("sw_var", variantName, 1);
            setCookie("sw_var_ver", version, 1);
            return variantName;
        }
    }

    function setCookie (cookieName, cookieValue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var domainName = window.location.host.substring(window.location.host.lastIndexOf(".", window.location.host.lastIndexOf(".") - 1) + 1);
        var cookieString = cookieName + "=" + cookieValue;
        cookieString += "; expires=" + d.toUTCString();
        cookieString += "; path=" + "/";
        cookieString += "; domain=" + domainName;
        cookieString += "; secure";
        cookieString += "; SameSite=None";
        document.cookie = cookieString;
    }

    function getCookie (cookieName) {
        var cookieArray = decodeURIComponent(document.cookie).split(';');
        for(var i = 0; i < cookieArray.length; i++) {
            var c = cookieArray[i];
            while (c.charAt(0) == ' '){c = c.substring(1);}
            if (c.indexOf(cookieName + "=") == 0) return c.substring((cookieName + "=").length, c.length);
        }
        return null;
    }

    function deleteCookie(name) {
        document.cookie = name +'=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;';
    }

    function searchURL (string, success, fail) {
        return (window.location.href.indexOf(string) > -1) ? success(string) : fail(); // replace with findMatch function
    }

    function findGetParameter(parameterName) {
        var result = null,
            tmp = [];
        var items = location.search.substr(1).split("&");
        for (var i = 0; i < items.length; i++) {
            tmp = items[i].split("=");
            if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
        }
        return result;
    }

    function findHashtag(parameterName) {
        var result = null,
            tmp = [];
        var items = location.hash.substr(1).split("#");
        for (var i = 0; i < items.length; i++) {
            tmp = items[i].split("=");
            if (tmp.length === 2 && tmp[0] === parameterName) {
                var cutLocation = tmp[1].indexOf("?");
                if (cutLocation > 0) tmp[1] = tmp[1].substr(0, cutLocation);
                result = decodeURIComponent(tmp[1]);
            }
        }
        return result;
    }

    function forceVariant(string) {
        var variant = findHashtag(string) || findGetParameter(string);
        if ( variant && variant !== "undefined" ) {
            // custom variant was defined
            console.log("Swogo-LOG","Force Swogo variant enabled - " + variant + " script deployed.");
            setCookie("sw_var", variant, 1);
        }
        setCookie("sw_var_ver", version, 1);
    }

    function deleteDevVariantCookies() {
        if ( getCookie("sw_var") && getCookie("sw_var").indexOf("DEV") >= 0 ) {
            deleteCookie("sw_var");
            deleteCookie("sw_var_ver");
        }
    }
}

initialize();
/* set trigger event */

//window.addEventListener('load',initialize);